/*


*/
/* example-start filesel filesel.c */

#include <gtk/gtk.h>

/* Get the selected filename and print it to the console */
void file_ok_sel( GtkWidget        *w,
                  GtkFileSelection *fs )
{
    g_print ("%s\n", gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));
}

void destroy( GtkWidget *widget,
              gpointer   data )
{
    gtk_main_quit ();
}

void action_chooserselection_made(GtkWidget * w) {
	
	char *selected_file;
	//char **selected_dir;
	//char *text;
    //char *filename;
    
   	/* this gives the file name but not the path */
	selected_file = gtk_entry_get_text(GTK_ENTRY(w));
	g_print("Selected file is: %s\n", selected_file);
	
	return;
}


int main( int   argc,
          char *argv[] )
{
    GtkWidget *window, *Widget, *filew;
    
    gtk_init (&argc, &argv);
    
    /* create a new window */
    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    
	gtk_signal_connect (GTK_OBJECT (window), "destroy",
                        GTK_SIGNAL_FUNC (destroy), NULL);
    
    /* Create main container */
    Widget=gtk_vbox_new(FALSE, 5);
    
    gtk_container_add(GTK_CONTAINER(window), Widget);
    
    /* add a hbox with a label to Widget */
    GtkWidget* Test = gtk_hbox_new(FALSE, 5);
    GtkWidget* Label = gtk_label_new("Test label in the main box. Below embedded fileselect:");
    gtk_box_pack_start(GTK_BOX(Widget), Test, TRUE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(Test), Label, TRUE, TRUE, 0);
    gtk_widget_show(Test);
    gtk_widget_show(Label);
       
    /* Create a new file selection widget */
    filew = gtk_file_selection_new ("File selection");
    
    /* Hide buttons for create directory, delete and rename file: */
    gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(filew));
    
    /* Remove ok and cancel buttons */
	gtk_object_destroy(GTK_OBJECT(GTK_FILE_SELECTION(filew)->ok_button));
	gtk_object_destroy(GTK_OBJECT(GTK_FILE_SELECTION(filew)->cancel_button));
        
    /* reparent inner vbox of fileselect */
    gtk_widget_reparent(GTK_FILE_SELECTION(filew)->main_vbox, Widget);
    
    /* below works but only gives filename */
   	gtk_signal_connect(GTK_OBJECT
		(GTK_FILE_SELECTION(filew)->selection_entry),
		"changed", (GtkSignalFunc)(action_chooserselection_made),
		(gpointer) Widget);
        
    /*gtk_signal_connect (GTK_OBJECT (filew), "destroy",
                        (GtkSignalFunc) destroy, &filew);*/
                        
    /* Connect the ok_button to file_ok_sel function */
   /* gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),
                        "clicked", (GtkSignalFunc) file_ok_sel, filew );*/
    
    /* Connect the cancel_button to destroy the widget */
   /* gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION
                                            (filew)->cancel_button),
                               "clicked", (GtkSignalFunc) gtk_widget_destroy,
                               GTK_OBJECT (filew));*/
    
    /* Lets set the filename, as if this were a save dialog, and we are giving
     a default filename */
   /* gtk_file_selection_set_filename (GTK_FILE_SELECTION(filew), 
                                     "penguin.png");*/
   
    gtk_widget_show(Widget);
    gtk_widget_show(window);
    gtk_main ();
    return 0;
}
/* example-end */
